/** Update component component properties */
try{
    // Init component \see data in component html
    function onInitComponent(data){
        //console.log("[onInitComponent][" + data.source() + "][" + data + "]");
        onUpdate_mainframe(data);
        onGuiInit_vivaldigiovefree(data);
        return true;
    }
    // compones-mainframe.html callback
    function onGuiChangeGateway(sender,gateway,data) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
        return onUpdate_protocol(gateway.getProtocol(), data);
    }

    function onGuiSelect(oNode) {
       // console.log("selected");
        return true;
    }
    function onGuiDeselect(oNode) {
        //console.log("[onGuiChangeGateway][" + sender.source + "][" + gateway.getProtocol() + "][" + data + "]");
        //return updateProtocol(gateway.getProtocol(),data);
    //    console.log($("propertiesblock").val());
      //  console.log("deselected");

        return true;
    }



    /** On Update Component Function (Required)
     * Update component when some change has occured
     */
    function onUpdateComponent(data){
        onUpdate_protocol(data.protocol(), data);

        /* ad ogni update  del componente la funzione onDeselect viene ridefinita
        quindi in un dato istante ne esiste solo una, quella del componente selezionato.
         */
        onDeselect = function () {
      //      $("#mycomponents .extra").hide();
       //     console.log("scenario deselected");
       //     console.log($("#propertiesblock").prop('checked'));
            if ($("#propertiesblock").prop('checked')==true) return false;
            try{
                $("#mycomponents").find("[eve-manager-component]:not([eve-manager-component='group'])").draggable("destroy");
            }
            catch(ex)
            {}
            return true;
        }

        onSelect = function () {
        //    $("#mycomponents .extra").show();
        //    console.log("scenario selezionato");
            return true;
        }

        onGroupOpen = function () {
         //   console.log("gruppo aperto");
            $("#mycomponents").find("[eve-manager-component]:not([eve-manager-component='group'])").draggable({
                appendTo: "body",
                containment: "body",
                revert: "invalid",
                revertDuration: false,
                connectToSortable: $("#scenarioEditor").find(".attachcomponent, .actions"),
                helper: function(e){ return $(e.currentTarget).clone(true); },
                start: function(e,ui){
                    m_$element.find(".actions-box").addClass("accept");

                },
                stop: function(e,ui){
                    m_$element.find(".actions-box").removeClass("accept");
                },
                zIndex: 1000
            });
            return true;
        }


        $("#mycomponents").find("[eve-manager-component]:not([eve-manager-component='group'])").draggable({
            appendTo: "body",
            containment: "body",
            revert: "invalid",
            revertDuration: false,
            connectToSortable: $("#scenarioEditor").find(".attachcomponent, .actions"),
            helper: function(e){ return $(e.currentTarget).clone(true); },
            start: function(e,ui){
                m_$element.find(".actions-box").addClass("accept");

            },
            stop: function(e,ui){
                m_$element.find(".actions-box").removeClass("accept");
            },
            zIndex: 1000
        });

        var oComponent = data.node();
        //Check
        if(! (oComponent instanceof Component) ){
            throw "oComponent is not a Component instance";
            return false;
        }

        $("[eve-manager-id='UID']").text(oComponent.UId);
        $("[eve-manager-id='type']").text(oComponent.type);
        
        //Set name
        var $Elem = $componentProperties.find("[eve-manager-id='name']");
        $Elem.val(oComponent.getParamVal("name"));
        
        //Set html name
        $Elem = $("#"+ oComponent.id +" .components-text");
        $Elem.text(oComponent.getParamVal("name"));
        
        //Build gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway']");
        $.publish("/view/gateways/refresh/dependencies");
        
        //Select gateways
        $Elem = $componentProperties.find("[eve-manager-id='gateway'] option");
        $componentProperties.find(".protocols").hide();                                             //Hide all protocols
        for(var i=0; i<$Elem.length; ++i){
            var $currElem = $($Elem[i]);
            var oNode = $currElem.data("eveManagerNode");
            var strProtocol;
            
            //Find gateway
            if(oNode === oComponent.getParamVal("gateway")){
                
                $currElem.prop("selected",true);                                                    //Select gateway
                if(oNode == undefined){ break; }                                                    //If none gateway is selected break for cicle
                
                var oGateway = oNode.getData();                                                     //Get node data (gateway)
                
                strProtocol = oGateway.getProtocol();                                               //Get protocol id
                $componentProperties.find("[eve-manager-protocol='"+ strProtocol +"']").show();     //Show protocol view
                break;
            }
        }
        
        //Set enable history
        $Elem = $("[eve-manager-id='history']");
        $Elem.prop("checked",oComponent.getParamVal("history"));
        
        //Set enable history
        $Elem = $("[eve-manager-id='savelastvalue']");
        $Elem.prop("checked",oComponent.getParamVal("savelastvalue"));
        
        //Set enable cache
        $Elem = $("[eve-manager-id='cache']");
        $Elem.prop("checked",oComponent.getParamVal("cache"));


        //Set icon
        $Elem = $componentProperties.find("[eve-manager-id='icons']");
        var aIcons = oComponent.getParamVal("icons");
        $.publish("/view/components/"+ oComponent.id +"/refresh/parameter",[oComponent,"icons"]);
        
        /** Ghost updates */

        //Set linked with (ghost scenario type)
        $Elem = $("[eve-manager-protocol='ghost'] .linkedwith");
        var oComposition = oComponent.getParamVal("ghost");
        
        if(oComposition != undefined && oComposition.attached != undefined && oComposition.attached.UId != undefined){
            var oAttachedNode = application.getComponentByUid( oComposition.attached.UId );

            if(oAttachedNode != undefined){
                var oAttachedComponent = oAttachedNode.getData();
                var oParentAttachedNode = oAttachedNode.getParent();
                var oAttachedParent = oParentAttachedNode.getData();
                var strAtt = (oAttachedParent.getParamVal) ? oAttachedParent.getParamVal("name") : _D("none");
                strAtt += " - ";
                strAtt += oAttachedComponent.getParamVal("name");
                $Elem.text(strAtt);
            }
            else{
                oComposition.attached = undefined;
                console.warn("Attached component don't exist anymore");
            }
        }
        else{ $Elem.text("n.d."); }
        
        //Set linked with (ghost scenario type)
        $Elem = $("[eve-manager-protocol='ghost'] .actions");

        //Fill components actions
        if(oComposition != undefined && oComposition.actions != undefined){
            var $actions = m_$element.find(".actions");
            $actions.empty();
            for(var i=0; i<oComposition.actions.length; ++i){
                var oTempNode = application.getComponentByUid( oComposition.actions[i].UId );
                var oTempComponent = oTempNode.getData();
                var oTempParent = oTempNode.getParent();
                var oTempParentComponent = oTempParent.getData();
                var oDescriptor = oTempComponent.getDescriptor();
                var $element = self._addAction( application.getComponentByUid( oComposition.actions[i].UId ));

                //Set element parameters
                var $value = $element.find(".value");
                $element.find(".category").text((oTempParentComponent.getParamVal)?oTempParentComponent.getParamVal("name"):_D("none"));
                $element.find(".name").text(oTempComponent.getParamVal("name"));
                $value.val(oComposition.actions[i].value);

                if(oTempComponent.getType() == "rgb-light") {
                  //  console.log($element.find(".value").val(oComposition.actions[i].value));
                    $element.find(".value").css("background-color","#"+ oComposition.actions[i].value);
                }else if(oTempComponent.getType() == "slider") {
                    $value.val($value.val()*100);
                }

                var $componentActions = $element.find(".options");

                $componentActions.find("[value='"+ oComposition.actions[i].action +"']").prop("selected",true);

                $element.data("eveManagerNode",oTempNode);
                $actions.append($element);
            }
        }

      //  $Elem.html(strHtml);

        //FUNZIONE RESPONSABILE DI MODIFICARE TUTTI I PARAMETRI DEL COMPONENTE HTML

        /** KNX updates */
        
        //Set KNX write address
        $Elem = $componentProperties.find("[eve-manager-id='knx/write-address']");
        var aValue = oComponent.getParamVal("knx/write-address").split("/");
        for(var i = 0; i<aValue.length; ++i){
            $Elem[i].value = aValue[i];
        }
        
        //Set knx - scene value
        $Elem = $componentProperties.find("[eve-manager-id='knx/scene-value']");
        $Elem.val(oComponent.getParamVal("knx/scene-value"));
        
        //Set KNX - functional block
        $Elem = $componentProperties.find("[eve-manager-id='knx/functional-block'] option");
        for(var i = 0; i < $Elem.length; ++i){
            var $currElem = $($Elem[i]);
            
            if($currElem.val() == oComponent.getParamVal("knx/functional-block")){
                $currElem.prop("selected",true);                                                    //Select format
                break;
            }
        }

        $Elem = $componentProperties.find("[eve-manager-id='knx/virtual-feedback']");
        $Elem.prop("checked",oComponent.getParamVal("knx/virtual-feedback"));


        /** VIMAR By Me */
        
        //Set Vimar group address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/group-address']");
        $Elem.val(oComponent.getParamVal("vimar/group-address"));
        
        //Set Vimar physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/value']");
        $Elem.val(oComponent.getParamVal("vimar/value"));
        
        //Set Vimar physical address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/physical-addresses']");
        $Elem.val(oComponent.getParamVal("vimar/physical-addresses"));

        //Set simulation feedback
        var $Elem = $componentProperties.find("[eve-manager-id='vimar/enable-sfbk']");
        $Elem.prop("checked", oComponent.getParamVal("vimar/enable-sfbk") );

        //Set simulation feedback address
        $Elem = $componentProperties.find("[eve-manager-id='vimar/sfbk']");
        var aValue = oComponent.getParamVal("vimar/sfbk").split("/");
      //  console.log($Elem[0]);

        for(var i = 0; i<aValue.length; ++i){
            if ($Elem[i]!=undefined){
                $Elem[i].value = aValue[i];
            }
        }

        /** Datagram */

        //Set Datagram - HEX Char
        $Elem = $componentProperties.find("[eve-manager-id='datagram/hex-char']");
        $Elem.val(oComponent.getParamVal("datagram/hex-char"));
        
        //Set Datagram - Command
        $Elem = $componentProperties.find("[eve-manager-id='datagram/command']");
        $Elem.val(oComponent.getParamVal("datagram/command"));

        // Set Datagram - Broadcast
        $Elem = $componentProperties.find("[eve-manager-id='datagram/broadcast']");
        $Elem.prop("checked",oComponent.getParamVal("datagram/broadcast"));

        /** Http **/
        $Elem = $componentProperties.find("[eve-manager-id='http/path']");
        $Elem.val(oComponent.getParamVal("http/path"));
        $Elem = $componentProperties.find("[eve-manager-id='http/data']");
        $Elem.val(oComponent.getParamVal("http/data"));
        $Elem = $componentProperties.find("[eve-manager-id='http/response']");
        $Elem.val(oComponent.getParamVal("http/response"));

        // Disable data field if request is GET type
        if (data.protocol() == "http") {
            $Elem = $componentProperties.find("[eve-manager-id='http/data']");
            if (data.gateway().getData().getParamVal("http/request") == 0) { // GET
                $Elem.attr("disabled",true); 
            } else {
                $Elem.attr("disabled",false);
            }
        }

        /** Vivaldi */
        {
            var json = blr.declarations.vivaldi.devices;
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-pid']");

            //Parsing Vivaldi Devices
            for(var i=0; i<json.length; ++i){
                var $option = $("<option></option>");

                    $option.text(json[i].itemCodes.toString() +" - "+ _D(json[i].label));
                    $option.attr("title", _D(json[i].label));
                    $option.val(json[i].pid);
                    $option.data("Vivaldi",json[i]);

                    //Append
                    $dropDown.append($option);
            }

            //Select currently PID
            var devicePID = oComponent.getParamVal("vivaldi/device-pid");
            var $selected = $dropDown.find("[value='"+ devicePID +"']");
            var oVivaldiDevice = $selected.data("Vivaldi");

            //Select vivaldi device
            $selected.prop("selected",true);

            //Fill RC20 address
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-id']");
            for(var i=0; i<oVivaldiDevice.idList.length; ++i){
                var $option = $("<option></option>");
                $option.text(oVivaldiDevice.idList[i]);
                $option.val(oVivaldiDevice.idList[i]);

                $dropDown.append($option);
            }

            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-id") +"']");
            $selected.prop("selected",true);

            if(devicePID == 1) {
                $dropDown.prop("disabled",true);
            } else if(devicePID == 2) {
                $dropDown.removeProp("disabled");
            }

            //Fill Function ID
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']");
            for(var i=0; i<oVivaldiDevice.fidList.length; ++i){

                if(devicePID == 2) {
                    if(oVivaldiDevice.fidList[i].fid != 7 && oVivaldiDevice.fidList[i].fid != 8){
                        continue;
                    }
                }


                var $option = $("<option></option>");
                $option.text(_D(oVivaldiDevice.fidList[i].label));
                $option.val(oVivaldiDevice.fidList[i].fid);

                $dropDown.append($option);
            }

            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/device-fid") +"']");
            $selected.prop("selected",true);


            //Fill Value depending on Function ID
            $dropDown = $componentProperties.find("[eve-manager-id='vivaldi/value']");
            $dropDown.empty();
            if(devicePID == 1) {
                var functionID = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']").val();
                if(functionID == 3) { //Scenario
                    for (var i=1;i<=16;i++) {
                        var $option = $("<option></option>");
                        $option.text(i);
                        $option.val(i);

                        $dropDown.append($option);
                    }
                } else if(functionID == 5) { //IR
                    for (var i=1;i<=50;i++) {
                        var $option = $("<option></option>");
                        $option.text(i);
                        $option.val(i);

                        $dropDown.append($option);
                    }
                }

            } else if(devicePID == 2) { //room controller, cd e track
                var functionID = $componentProperties.find("[eve-manager-id='vivaldi/device-fid']").val();
                if(functionID == 7 || functionID == 8) { //Prev Next
                    var $option = $("<option></option>");
                    $option.text(_D("Previous"));
                    $option.val(101);

                    $dropDown.append($option);

                    $option = $("<option></option>");
                    $option.text(_D("Next"));
                    $option.val(102);

                    $dropDown.append($option);
                }
            }

            var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("vivaldi/value") +"']");
            $selected.prop("selected",true);
        }
        
        /** BTicino */  
       	{
                var json = blr.declarations.bticino.functions;
                $dropDown = $componentProperties.find("[eve-manager-id='bticino/who']");
                var $none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");
                $dropDown.append($none);
                

				//Parsing BTicino WHOs
				// 1 stands for illuminations, 2 automatisms, 0 scenario
				for (var i = 0; i < json.length; ++i) {
					if (json[i].who == 0 || json[i].who == 1 || json[i].who == 2) {
						var $option = $("<option></option>");
						$option.text(_D(json[i].label));
						$option.attr("title", _D(json[i].label));
						$option.attr("dictionary", json[i].label);
						$option.val(json[i].who);
						$option.data("BTicino", json[i]);
						$dropDown.append($option);
					}
				}

                           
                //currently selected WHO
                var $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/who") +"']");
                var oBTicino = $selected.data("BTicino");
              	$selected.prop("selected",true);
              	
              	var who = oComponent.getParamVal("bticino/who");
              			
				//populate interface dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/interface']");
               	$none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");             
                
				if (who != 'none' && (who == 0 || who == 1 || who == 2)) {
					for (var i = 0; i < oBTicino.interfaces.length; ++i) {

						var $option = $("<option></option>");
						$option.text(_D(oBTicino.interfaces[i].label));
						$option.attr("title", _D(oBTicino.interfaces[i].label));
						$option.attr("dictionary", oBTicino.interfaces[i].label);
						$option.val(oBTicino.interfaces[i].bus);

						//Append
						$dropDown.append($option);

					}
				} else {
					$dropDown.append($none);
					$dropDown.prop("disabled",true);
				}
       
                $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/interface") +"']").prop("selected",true);
               
                //populate address dropdown
               	$dropDown = $componentProperties.find("[eve-manager-id='bticino/address']");
               	$none = $("<option value='none' dictionary='None'>"+ _D("None") +"</option>");

				if (who != 'none' && (who == 0 || who == 1 || who == 2)) {
					for (var i = 0; i < oBTicino.scenarioAddresses.length; ++i) {
						var $option = $("<option></option>");
						$option.text(_D(oBTicino.scenarioAddresses[i].label));
						$option.attr("title", _D(oBTicino.scenarioAddresses[i].label));
						$option.attr("dictionary", oBTicino.scenarioAddresses[i].label);
						$option.val(oBTicino.scenarioAddresses[i].where);

						//Append
						$dropDown.append($option);

					}
				} else {
					$dropDown.append($none);
					$dropDown.prop("disabled",true);
				}

                $selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/address") +"']").prop("selected",true);



				//populate function dropdown
				$dropDown = $componentProperties.find("[eve-manager-id='bticino/function']");
				$none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

				if (who != 'none' && (who == 0 || who == 1 || who == 2)) {
					for (var i = 0; i < oBTicino.functions.length; ++i) {
						var $option = $("<option></option>");
						$option.text(_D(oBTicino.functions[i].label));
						$option.attr("title", _D(oBTicino.functions[i].label));
						$option.attr("dictionary", oBTicino.functions[i].label);
						$option.val(oBTicino.functions[i].fid);

						//Append
						$dropDown.append($option);
					}
				} else {
					$dropDown.append($none);
					$dropDown.prop("disabled",true);
				}

				$selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/function") +"']").prop("selected",true);
	               	             
             
                //populate value dropdown
				$dropDown = $componentProperties.find("[eve-manager-id='bticino/value']");
				$none = $("<option value='none' dictionary='None'>" + _D("None") + "</option>");

				if (who != 'none' && (who == 0 || who == 1 || who == 2)) {
					for (var i = 0; i < oBTicino.values.length; ++i) {

						var $option = $("<option></option>");
						$option.text(_D(oBTicino.values[i].label));
						$option.attr("title", _D(oBTicino.values[i].label));
						$option.attr("dictionary", oBTicino.values[i].label);
						$option.val(oBTicino.values[i].value);

						//Append
						$dropDown.append($option);
					}
				} else {
					$dropDown.append($none);
					$dropDown.prop("disabled",true);
				};
		
				$selected = $dropDown.find("[value='"+ oComponent.getParamVal("bticino/value") +"']").prop("selected",true);

        }


        // Modbus
        {
                var json = blr.declarations.modbus.functions;
                //unit_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
                for(var i=0; i<json.unit_id.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.unit_id[i].label));
                    $option.attr("title", _D(json.unit_id[i].label));
                    $option.attr("dictionary", json.unit_id[i].label);
                    $option.val(json.unit_id[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-unit-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-unit-id") +"']").prop("selected",true);

                //switch_transform_type
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
                for(var i=0; i<json.switch_transform_type.length; ++i){
                    var $option = $("<option></option>");
                    $option.text(_D(json.switch_transform_type[i].label));
                    $option.attr("title", _D(json.switch_transform_type[i].label));
                    $option.attr("dictionary", json.switch_transform_type[i].label);
                    $option.val(json.switch_transform_type[i].value);
                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownRtuWrite.append($option.clone());
                    $dropDownTcpRead.append($option.clone());
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-transform-type") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-transform-type") +"']").prop("selected",true);


                //read_function_id
                $dropDownRtuRead = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
                $dropDownTcpRead = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
                for(var i=0; i<json.read_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.read_function_id[i].label));
                    $option.attr("title", _D(json.read_function_id[i].label));
                    $option.attr("dictionary", json.read_function_id[i].label);
                    $option.val(json.read_function_id[i].value);

                    //Append
                    $dropDownRtuRead.append($option);
                    $dropDownTcpRead.append($option.clone());
                }
                $selected = $dropDownRtuRead.find("[value='"+ oComponent.getParamVal("modbusrtutcp/read-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpRead.find("[value='"+ oComponent.getParamVal("modbustcp/read-function-id") +"']").prop("selected",true);


                //write_function_id
                $dropDownRtuWrite = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
                $dropDownTcpWrite = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
                for(var i=0; i<json.write_function_id.length; ++i){

                    var $option = $("<option></option>");
                    $option.text(_D(json.write_function_id[i].label));
                    $option.attr("title", _D(json.write_function_id[i].label));
                    $option.attr("dictionary", json.write_function_id[i].label);
                    $option.val(json.write_function_id[i].value);

                    //Append
                    $dropDownRtuWrite.append($option);
                    $dropDownTcpWrite.append($option.clone());
                }
                $selected = $dropDownRtuWrite.find("[value='"+ oComponent.getParamVal("modbusrtutcp/write-function-id") +"']").prop("selected",true);
                $selected = $dropDownTcpWrite.find("[value='"+ oComponent.getParamVal("modbustcp/write-function-id") +"']").prop("selected",true);

            }

        // ModbusTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/read-transform-multiplier"));

        // ModbusTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbustcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbustcp/write-transform-multiplier"));


        // ModbusRTUTCP Read
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/read-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/read-transform-multiplier"));

        // ModbusRTUTCP Write
        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-unit-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-unit-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-function-id']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-function-id"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-register-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-register-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-start']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-start"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-bit-count']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-bit-count"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-type']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-type"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-min']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-min"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-max']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-max"));

        $Elem = $componentProperties.find("[eve-manager-id='modbusrtutcp/write-transform-multiplier']");
        $Elem.val(oComponent.getParamVal("modbusrtutcp/write-transform-multiplier"));

    };

    function onUpdate_protocol(strProtocol, data) {
        switch (strProtocol) {
            case "vivaldigiovefree": {
                return onUpdate_vivaldigiovefree(data);
            } break;
            case "ghost": {
                return onUpdate_ghost(data);
            } break;
            default: {
                return onUpdate_default(data);
            }
        }
        return false;
    }

    function onUpdate_mainframe(data) {
        var $Elem = undefined;

        return true;
    }
    function onGuiInit_vivaldigiovefree(data) {
        //console.log("onGuiInit_vivaldigiovefree");
        var jsonData = blr.declarations.vivaldi.giovefree.addresses;
        var $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-id']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i]);
            $option.text(jsonData[i]);
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-id") + "']");
        $selected.prop("selected", true);

        jsonData = blr.declarations.vivaldi.giovefree.scenario_fids;
        $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/device-fid']");
        for (var i = 0; i < jsonData.length; ++i) {
            var $option = $("<option></option>");
            $option.val(jsonData[i].fid);
            $option.text(_D(jsonData[i].label));
            $dropDown.append($option);
        }
        var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/device-fid") + "']");
        $selected.prop("selected", true);

        // update combo values if necessary
        var paramID = parseInt(data.node().getParamVal("vivaldigiovefree/device-fid"), 10);
        switch (paramID) {
            case 12: { // IRScene
                var $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/value']");
                $dropDown.empty();
                var jsonData = blr.declarations.vivaldi.giovefree.irscene_values;
                for (var i = 0; i < jsonData.length; ++i) {
                    var $option = $("<option></option>");
                    $option.val(jsonData[i]);
                    $option.text(_D(jsonData[i]));
                    $dropDown.append($option);
                }
                var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/value") + "']");
                $selected.prop("selected", true);
            } break;
            case 13: { // Scene
                var $dropDown = data.$properties().find("[eve-manager-id='vivaldigiovefree/value']");
                $dropDown.empty();
                var jsonData = blr.declarations.vivaldi.giovefree.scene_values;
                for (var i = 0; i < jsonData.length; ++i) {
                    var $option = $("<option></option>");
                    $option.val(jsonData[i]);
                    $option.text(_D(jsonData[i]));
                    $dropDown.append($option);
                }

                var maxValue = jsonData[jsonData.length - 1];
                var val = parseInt(data.node().getParamVal("vivaldigiovefree/value"), 10);
                if (val > maxValue) { val = maxValue; }

                var $selected = $dropDown.find("[value='" + data.node().getParamVal("vivaldigiovefree/value") + "']");
                $selected.prop("selected", true);
            } break;
        }

        return true;
    }

    function onGuiChange_vivaldigiovefree(sender) {
        //console.log("onGuiChange_vivaldigiovefree");
        var oNode = application.getSelectComponent().getData();
        var $this = $(sender);
        var strParam = $this.attr("eve-manager-id");
        var strValue = $this.find(":selected").val();

        if (strParam == "vivaldigiovefree/device-fid") {
            switch (parseInt(strValue,10)) {
                case 12: { // IRScene
                    var $dropDown = $("#componentproperties").find("[eve-manager-id='vivaldigiovefree/value']");
                    $dropDown.empty();
                    var jsonData = blr.declarations.vivaldi.giovefree.irscene_values;
                    for (var i = 0; i < jsonData.length; ++i) {
                        var $option = $("<option></option>");
                        $option.val(jsonData[i]);
                        $option.text(_D(jsonData[i]));
                        $dropDown.append($option);
                    }
                    var $selected = $dropDown.find("[value='" + oNode.getParamVal("vivaldigiovefree/value") + "']");
                    $selected.prop("selected", true);
                } break;
                case 13: { // Scene
                    var $dropDown = $("#componentproperties").find("[eve-manager-id='vivaldigiovefree/value']");
                    $dropDown.empty();
                    var jsonData = blr.declarations.vivaldi.giovefree.scene_values;
                    for (var i = 0; i < jsonData.length; ++i) {
                        var $option = $("<option></option>");
                        $option.val(jsonData[i]);
                        $option.text(_D(jsonData[i]));
                        $dropDown.append($option);
                    }

                    var maxValue = jsonData[jsonData.length-1];
                    var val = parseInt(oNode.getParamVal("vivaldigiovefree/value"), 10);
                    if (val > maxValue) { val = maxValue; }
                    oNode.setParamVal("vivaldigiovefree/value", val);
                    var $selected = $dropDown.find("[value='" + oNode.getParamVal("vivaldigiovefree/value") + "']");
                    $selected.prop("selected", true);
                } break;
            }
        }

        //Save in Model
        $.publish("/model/components/" + oNode.id + "/update/parameter", [oNode, strParam, strValue]);
        $.publish("/view/components/" + oNode.id + "/refresh/parameter", [oNode, strParam]);
        return true;
    }

    function onUpdate_vivaldigiovefree(data) {
        //console.log("onUpdate_vivaldigiovefree");
        // We set the current value under onGuiInit, so the value is always synced
        return true;
    }

    function onUpdate_ghost(data) {
        //Set virtual feedback
        var $Elem = data.$properties().find("[eve-manager-id='ghost/virtual-feedback']");
        $Elem.prop("checked", data.node().getParamVal("ghost/virtual-feedback"));

        $Elem = data.$properties().find("[eve-manager-id='ghost/userdata']");
        $Elem.val(data.node().getParamVal("ghost/userdata"));

        return true;
    }
    function onUpdate_default(data) {
        return true;
    }
}
catch(err){
    console.error(err);
}
