/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    function onInitComponent(oComponent){

        //Call common initialize component inside mainframe
        //$.loadSyncScript("./components/mainframe/init.js");
        onInitMainframeComponent(oComponent);
        
        //Set default values using Publish/Subscribe pattern
        oComponent.addParamVal("name",_D("uPNP")+" "+oComponent.UId);
        
        //Select default Gui gateway
        oComponent.setParamVal("gateway",application.getGatewaysByProtocol("gui")[0]);

        var aIcons = oComponent.getParamVal("icons");
        var oIcon_status_0 = new Icon();


        /** ABILITARE I COMMENTI PER AGIUNGERE ICONA
         *
         */

        //var oIcon_status_1 = new Icon();
        var oDefaultPan = application.ResoucesManager.getDefaultIconsPan();
        
        $.extend(true, oIcon_status_0, {
            status: 0,
            position:{ x: 0, y: -128 },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: 128, w: 128 },
            setSize: { h: 2048, w: 2048 }
        });
        /*$.extend(true, oIcon_status_1, {
            status: 1,
            position:{ x: 0, y: -128 },
            enableColors: false,
            srcId: oDefaultPan["id"],
            size: { h: 128, w: 128 },
            setSize: { h: 2048, w: 2048 }
        });*/
        
        //Important: maintain original position
        aIcons.push(oIcon_status_0);
        //aIcons.push(oIcon_status_1);

        oComponent.addParamVal("viewmodelist",[ 
        		{id:0, label:"Classic"}
        		//,{id:1, label:"Modal"}
        		//,{id:2, label:"Only Text"}
        		//,{id:3, label:"Hidden"} 
        	]);

        // Components
        // BEGIN MUST BE ALWAYS EXIST
        oComponent.addParamVal("gui/components-list",[
        ]);
        oComponent.addParamVal("gui/components", new Array() );
        // END MUST BE ALWAYS EXIST

        // Component Parameters

        oComponent.addParamVal("gui/destinationid","");
        oComponent.addParamVal("EVEUIStyle","onlyMap");

    }
}
catch(err){
    console.error(err);
}
