/** Initialize component when component is dragged to component list (onCreateComponent must be exist in each html component file) */
try{
    /** On Define Component Function (Required)
     * Initialize component behavior for virtual scenario composition
     */
    function onDefineComponent(oComponent){
        var oDescriptor = oComponent.getDescriptor();
        var defaultAction = 0;
        var defaultValue = 0;
        
        /**
         * Param 1 -> Type; Param 2 -> Min; Param 3 -> Max; Param 4 -> Default
         */
        oDescriptor.setValueDescription(0,0,0,defaultValue);
        
        oDescriptor.addDescription(0,_D("Call"));
        
        //Set editables
        oDescriptor.setActionEditable(false);
        oDescriptor.setValueEditable(false);
    };
}
catch(err){
    console.error(err);
}