﻿
function change_modbustcp_settings(node) {
    if (node == undefined) { return; }
    var oGateway = node.data.getParamVal("gateway");
    if (oGateway != undefined) {
        if (oGateway.data.getProtocol() == "modbustcp") {
            var name = node.data.getParamVal("name");
            var id = parseInt(name.substr(1), 10);
            if (id < 65) {
                node.data.setParamVal("modbustcp/read-register-start", 999);
                node.data.setParamVal("modbustcp/read-register-count", 64);
                node.data.setParamVal("modbustcp/read-bit-start", (id - 1) * 16);
                node.data.setParamVal("modbustcp/read-bit-count", 1);
            }else{
                node.data.setParamVal("modbustcp/read-register-start", 1064);
                node.data.setParamVal("modbustcp/read-register-count", 64);
                node.data.setParamVal("modbustcp/read-bit-start", (id - 65) * 16);
                node.data.setParamVal("modbustcp/read-bit-count", 1);
            }
        }
    }
}

function read_node(node) {
    if (node != undefined) {
        // get gateway
        console.log(node.data.type + " -> " + node.data.getParamVal("name"));
        /*
         if (node.data.type == "group" && node.data.getParamVal("name") == "Furto 1") {
         var oGateway = node.data.getParamVal("gateway");
         if (oGateway != undefined) {
         if (oGateway.data.getProtocol() == "modbustcp") {

         }
         }
         }
         */

        var aChildren = node.children;
        for (var i = 0; i<aChildren.length; ++i) {
            read_node(aChildren[i]);
        }
    }
}


try {
    'use strict';
    console.log("%cStart script", "color:green;");

    var oNode = eveManager.getSelectComponent();
    if (oNode == undefined) {
        throw "Fatal Error";
    }

    var aChildren = oNode.children;
    for (var i = 0; i < aChildren.length; ++i) {
        change_modbustcp_settings(aChildren[i]);
    }

    /*
    var oRoot = eveManager.getComponentsRoot();
    if(oRoot == undefined){
        throw "Fatal Error";
    }

    var aChildren = oRoot.children;
    for (var i = 0; i < aChildren.length; ++i) {
        read_node(aChildren[i]);
    }
    */


}
catch (err) {
    console.error("Script file error: " + err);
    alert("Script file error: " + err);
}